﻿namespace TabsStudioMarker
{
    class CommandEventsListener
    {
        public CommandEventsListener(EnvDTE80.DTE2 dte_, SolutionStateSaver saver_)
        {
            dte = dte_;
            saver = saver_;
            events = dte.Events;
            commandEvents = events.get_CommandEvents(null, 0);
            commands = dte.Commands as EnvDTE80.Commands2;

            commandEvents.AfterExecute += OnAfterExecute;
        }

        public void Close()
        {
            commandEvents.AfterExecute -= OnAfterExecute;
        }

        private void OnAfterExecute(string Guid, int ID, object CustomIn, object CustomOut)
        {
            try
            {
                if (GetCommandInfo(Guid, ID).Equals("File.SaveAll"))
                    saver.Save();
            }
            catch (System.Exception)
            {
            }
        }

        // throw()
        private string GetCommandInfo(string Guid, int ID)
        {
            string result = "";
            if (Guid != null && commands != null)
            {
                try
                {
                    result = commands.Item(Guid, ID).Name;
                }
                catch (System.Exception)
                {
                }
            }
            return result;
        }

        private EnvDTE80.DTE2 dte;
        private SolutionStateSaver saver;
        private EnvDTE.Events events;
        private EnvDTE.CommandEvents commandEvents;
        private EnvDTE80.Commands2 commands;
    }
}
