﻿namespace AddinsCommon
{
    class VsVersion
    {
        enum Version
        {
            VS2008,
            VS2010,
            VS11,
            VS14,
            SSMS,
            SSMS2012,
            SSMS2016,
        };

        public VsVersion(EnvDTE80.DTE2 dte_)
        {
            dte = dte_;
            version = DetectVersion();
        }

        public bool IsWpfShell()
        {
            return version == Version.VS2010 || version == Version.VS11 || version == Version.VS14 || version == Version.SSMS2012 || version == Version.SSMS2016;
        }

        public bool IsExtension()
        {
            return version == Version.VS14 || version == Version.SSMS2016;
        }

        private Version DetectVersion()
	    {
		    if (dte.Name.Equals("Microsoft SQL Server Management Studio"))
		    {
			    string ssmsVersion = dte.Version.Substring(6, 2);
			    if(ssmsVersion.Equals("13"))
				    return Version.SSMS2016;
                return (ssmsVersion.Equals("11") || ssmsVersion.Equals("12")) ? Version.SSMS2012 : Version.SSMS;
		    }
		    if (dte.Version.Equals("10.0"))
                return Version.VS2010;
		    if (dte.Version.Equals("11.0") || dte.Version.Equals("12.0"))
                return Version.VS11;
            if (dte.Version.Equals("14.0") || dte.Version.Equals("15.0"))
                return Version.VS14;
            return Version.VS2008;
	    }

        private EnvDTE80.DTE2 dte;
        private Version version;
    }
}
